//EE2
//Ma-Jan-Mu
#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <string.h>

char	*tmpname = "@@TMP.DAT";

void decodeLZ77( unsigned char *inbuf, unsigned long size, unsigned char *outbuf )
{
	unsigned long	inpos = 9L;
	unsigned long	outpos = 0L;
	unsigned long	dicpos = 0L;
	unsigned char	byte;
	unsigned char	sign;
	unsigned int	counter;
	unsigned int	decode_startaddr;
	unsigned int	decode_length;
	int				i;
	int				q;

	while( inpos < size )
	{
		//compress sign
		sign = inbuf[inpos]; inpos++;

		for( i = 0; i != 8; i++ )
		{
			if( sign & 1 )
			{
				outbuf[outpos] = inbuf[inpos];
				inpos++; outpos++;
			} else {
				counter = *( unsigned int *)( inbuf + inpos );
				decode_length = ( counter & 31 ) + 3;		//5bit
				decode_startaddr = ( counter >> 5 ) + 1;	//11bit
				inpos += 2;

				//decode
				dicpos = outpos - decode_startaddr;
				for( q = 0; q != decode_length; q++ )
				{
					outbuf[outpos] = outbuf[dicpos+q];
					outpos++;
				}
			}
			sign >>= 1;
			if( inpos > size ) break;
		}
	}
}

void main( int argc, char **argv )
{
	FILE			*in;
	FILE			*out;
	unsigned char	*inbuf;
	unsigned char	*outbuf;
	unsigned long	filesize_original = 0L;
	unsigned long	filesize_compress = 0L;

	printf( "PONYTALE LZ1 Decompress tool 060128 (c)Fac.KUROHANE\n" );

	if( argc == 1 )
	{
		printf( "usage: EE2EXT <filename>\n" );
		return;
	}

	in = fopen( argv[1], "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", argv[1] );
		return;
	}

	//filesize
	fseek( in, 0, SEEK_END );
	filesize_compress = ftell( in );
	fseek( in, 0, SEEK_SET );

	printf( "filename: %s\n", argv[1] );

	//header
	inbuf = ( unsigned char * )calloc( 1, filesize_compress );
	fread( inbuf, filesize_compress, 1, in );
	fclose( in );

	if( memcmp( inbuf, "lz1", 3 ))
	{
		printf( "error: not LZ1 format.\n" );
		free( inbuf );
		return;
	}

	filesize_original = *( unsigned long *)( inbuf + 5 );
	printf( "filesize_compress: %lu bytes\n", filesize_compress );
	printf( "filesize_original: %lu bytes\n", filesize_original );

	outbuf = ( unsigned char * )calloc( 1, filesize_original );
	decodeLZ77( inbuf, filesize_compress, outbuf );

	free( inbuf );

	out = fopen( tmpname, "wb+" );
	if( out == NULL )
	{
		printf( "error: can't write tempfile.\n" );
		return;
	}
	fwrite( outbuf, filesize_original, 1, out );
	fclose( out );

	free( outbuf );

	remove( argv[1] );
	rename( tmpname, argv[1] );

	printf( "complete.\n" );

	return;
}
